"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/defineProperty"));

var _objectSpread3 = _interopRequireDefault(require("@babel/runtime/helpers/esm/objectSpread2"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/toConsumableArray"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/slicedToArray"));

var _ej2ReactTreegrid = require("@syncfusion/ej2-react-treegrid");

var _react = _interopRequireWildcard(require("react"));

var _datasource = require("../datasource");

require("./material.css");

require("./TreeGrid.css");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var TreeGrid = function TreeGrid() {
  var _useState = (0, _react.useState)({
    allowAdding: true,
    allowDeleting: true,
    allowEditing: true,
    newRowPosition: "Below" // mode: 'Cell'

  }),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      editOptions = _useState2[0],
      setEditOptions = _useState2[1];

  var _useState3 = (0, _react.useState)([]),
      _useState4 = (0, _slicedToArray2.default)(_useState3, 2),
      data = _useState4[0],
      setData = _useState4[1];

  var _useState5 = (0, _react.useState)([]),
      _useState6 = (0, _slicedToArray2.default)(_useState5, 2),
      keys = _useState6[0],
      setKeys = _useState6[1];

  var _useState7 = (0, _react.useState)(""),
      _useState8 = (0, _slicedToArray2.default)(_useState7, 2),
      inputColumn = _useState8[0],
      setInputColumn = _useState8[1];

  var _useState9 = (0, _react.useState)(false),
      _useState10 = (0, _slicedToArray2.default)(_useState9, 2),
      expanded = _useState10[0],
      setExpanded = _useState10[1];

  var ref = (0, _react.useRef)();

  var _useState11 = (0, _react.useState)(["Add"]),
      _useState12 = (0, _slicedToArray2.default)(_useState11, 2),
      toolbarSettings = _useState12[0],
      setToolbarSettings = _useState12[1];

  var _useState13 = (0, _react.useState)([]),
      _useState14 = (0, _slicedToArray2.default)(_useState13, 2),
      selectedColumns = _useState14[0],
      setSelectedColumns = _useState14[1];

  (0, _react.useEffect)(function () {
    setData(_datasource.summaryData);
  }, [_datasource.summaryData]);
  (0, _react.useEffect)(function () {
    if (data.length !== 0) {
      var keysarr = Object.keys(data[0]).filter(function (key) {
        return key !== "category";
      }).filter(function (key) {
        return key !== "subtask";
      });
      var initialArray = ["category"];
      initialArray.push.apply(initialArray, (0, _toConsumableArray2.default)(keysarr));
      setKeys(initialArray);
    }
  }, [data]);
  (0, _react.useEffect)(function () {
    if (!expanded) {
      var elements = document.getElementsByClassName("e-headercelldiv");

      for (var i = 0; i < elements.length; i++) {
        elements[i].classList.add("hide-treegridheader");
        elements[i].classList.remove("show-treegridheader");
      }
    }

    if (expanded) {
      var elements = document.getElementsByClassName("e-headercelldiv");

      for (var i = 0; i < elements.length; i++) {
        elements[i].classList.add("show-treegridheader");
        elements[i].classList.remove("hide-treegridheader");
      }
    }
  }, [expanded]);
  (0, _react.useEffect)(function () {
    //      document.getElementsByClassName("e-headertext")[0]?.classList.add("hide-treegridheader")
    // document.getElementsByClassName("e-headertext")[0]?.classList.remove("show-treegridheader")
    setTimeout(function () {
      var elements = document.getElementsByClassName("e-headercelldiv");

      for (var i = 0; i < elements.length; i++) {
        elements[i].classList.add("hide-treegridheader");
        elements[i].classList.remove("show-treegridheader");
      }

      var contentelements = document.getElementsByClassName("e-content");

      for (var i = 0; i < contentelements.length; i++) {
        contentelements[i].classList.add("hide-contentoverflow");
      }
    }, 100);
  }, []);

  var rowSelected = function rowSelected(treegrid) {// const a =args.getSelectedRowIndexes()
    // alert(JSON.stringify(args.data));
    // alert(args.data)
    // const a = ref.current.getSelectedRowIndexes()
    // console.log(a)
    // const ele = document.querySelector(`[aria-rowindex="${a}"]`)
    // const diva = document.createElement("a")
    // diva.id="over-id"
    // const m = document.getElementById("over-id")
    // diva.innerHTML="demo"
    // if(!ele.contains(m)){
    //   ele.appendChild(diva)
    // }
    // console.log(ele)
  };

  var customizeCell = function customizeCell(args) {
    var cell = args.cell;

    if (args.column.field !== "category") {
      cell.setAttribute("style", "background-color:#F4F5F7;background-clip:content-box;padding: 8px 21px;");
    }
  };

  var addColumn = function addColumn(inp) {
    var updated = data.map(function (obj) {
      return (0, _objectSpread3.default)((0, _objectSpread3.default)({}, obj), {}, (0, _defineProperty2.default)({}, inp, ""));
    });
    setData(updated);
    ref.current.refresh();
  };

  var autoFit = function autoFit() {
    ref.current.autoFitColumns(["category"]);
  };

  var handleExpand = function handleExpand() {
    setExpanded(true);
    var elements = document.getElementsByClassName("e-rowcell");

    for (var i = 0; i < elements.length; i++) {
      elements[i].classList.add("show-treegridborder");
      elements[i].classList.remove("hide-treegridborder");
    }

    var contentelements = document.getElementsByClassName("e-content");

    for (var i = 0; i < contentelements.length; i++) {
      contentelements[i].classList.add("show-contentoverflow");
      contentelements[i].classList.remove("hide-contentoverflow");
    }
  };

  var handleCollapse = function handleCollapse() {
    setExpanded(false);
    var elements = document.getElementsByClassName("e-rowcell");

    for (var i = 0; i < elements.length; i++) {
      elements[i].classList.add("hide-treegridborder");
      elements[i].classList.remove("show-treegridborder");
    }

    var contentelements = document.getElementsByClassName("e-content");

    for (var i = 0; i < contentelements.length; i++) {
      contentelements[i].classList.add("hide-contentoverflow");
      contentelements[i].classList.remove("show-contentoverflow");
    }
  };

  var handleColumnSelect = function handleColumnSelect(e) {
    if (e.target.checked) {
      setSelectedColumns(function (prevState) {
        return prevState.concat(e.target.name);
      });
    } else {
      setSelectedColumns(function (prevState) {
        return prevState.filter(function (item) {
          return item !== e.target.name;
        });
      });
    }
  };

  var handleDeleteRollup = function handleDeleteRollup() {
    for (var j = 0; j < data.length; j++) {
      for (var i = 0; i < selectedColumns.length; i++) {
        var x = data[j];

        if (x.hasOwnProperty(selectedColumns[i])) {
          delete x[selectedColumns[i]];
        }

        if (x.hasOwnProperty("subtask")) {
          for (var k = 0; k < x.subtask.length; k++) {
            for (var i = 0; i < selectedColumns.length; i++) {
              var y = x.subtask[k];

              if (y.hasOwnProperty(selectedColumns[i])) {
                delete y[selectedColumns[i]];
              }
            }
          }
        }
      }
    }

    ref.current.refresh();
    setTimeout(function () {
      if (data.length !== 0) {
        var keysarr = Object.keys(data[0]).filter(function (key) {
          return key !== "category";
        }).filter(function (key) {
          return key !== "subtask";
        });
        var initialArray = ["category"];
        initialArray.push.apply(initialArray, (0, _toConsumableArray2.default)(keysarr));
        setKeys(initialArray);
      }
    }, 100);
  };

  console.log(keys);

  var headerDiv = function headerDiv(heading, index) {
    return /*#__PURE__*/_react.default.createElement("div", null, heading === "category" ? /*#__PURE__*/_react.default.createElement("span", null, heading) : /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("input", {
      type: "checkbox",
      name: "".concat(heading),
      value: selectedColumns,
      onChange: function onChange(e) {
        return handleColumnSelect(e);
      }
    }), /*#__PURE__*/_react.default.createElement("span", null, heading)));
  }; //   const treegridTemplate =(props)=> {
  //     return (<tr>
  //       {keys.map((k)=>{
  //         return(
  // <td className="modifiedtd">
  //             <div className="modifiedcell">{props.k}</div>
  //         </td>
  //         )
  //       })
  //       }
  // </tr>);
  // }


  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("input", {
    placeholder: "column header",
    value: inputColumn,
    onChange: function onChange(e) {
      return setInputColumn(e.target.value);
    }
  }), /*#__PURE__*/_react.default.createElement("button", {
    onClick: function onClick() {
      return addColumn(inputColumn);
    }
  }, "add column"), /*#__PURE__*/_react.default.createElement("button", {
    onClick: function onClick() {
      return handleDeleteRollup();
    }
  }, "Delete rollup")), /*#__PURE__*/_react.default.createElement("div", {
    "data-testid": "treegrid-container",
    className: "TreeGrid-container ".concat(expanded ? "TreeGrid-container-expanded" : "TreeGrid-container-short")
  }, /*#__PURE__*/_react.default.createElement("div", null, !expanded ? /*#__PURE__*/_react.default.createElement("button", {
    className: "TreeGrid-viewbtn",
    "data-testid": "expandbutton",
    onClick: function onClick() {
      return handleExpand();
    }
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "fas fa-angle-double-right"
  })) : /*#__PURE__*/_react.default.createElement("button", {
    className: "TreeGrid-viewbtn",
    onClick: function onClick() {
      return handleCollapse();
    },
    "data-testid": "collapsebutton"
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "fas fa-angle-double-left"
  })), /*#__PURE__*/_react.default.createElement("i", {
    className: "far fa-plus-square fa-lg TreeGrid-menubtn ".concat(expanded && "TreeGrid-menubtnexpanded")
  })), data && data.length > 0 && /*#__PURE__*/_react.default.createElement(_ej2ReactTreegrid.TreeGridComponent, {
    dataSource: data,
    allowReordering: "true",
    childMapping: "subtask",
    allowResizing: true,
    treeColumnIndex: 0,
    toolbar: toolbarSettings,
    rowSelected: rowSelected,
    editSettings: editOptions,
    dataBound: autoFit // width="500px"
    ,
    ref: ref,
    queryCellInfo: customizeCell // rowTemplate={treegridTemplate}

  }, /*#__PURE__*/_react.default.createElement(_ej2ReactTreegrid.ColumnsDirective, null, keys.map(function (a, i) {
    return /*#__PURE__*/_react.default.createElement(_ej2ReactTreegrid.ColumnDirective, {
      field: a,
      headerTemplate: function headerTemplate() {
        return headerDiv(a, i);
      },
      visible: ["ID"].includes(a) ? false : true,
      isPrimaryKey: ["ID"].includes(a) ? true : false,
      lockColumn: ["category"].includes(a) ? true : false,
      allowResizing: ["category"].includes(a) ? false : true,
      allowEditing: ["category"].includes(a) ? true : false,
      key: a,
      width: "110px",
      textAlign: "Left"
    }); // }
  })), /*#__PURE__*/_react.default.createElement(_ej2ReactTreegrid.Inject, {
    services: [_ej2ReactTreegrid.Reorder, _ej2ReactTreegrid.Resize, _ej2ReactTreegrid.Edit, _ej2ReactTreegrid.Toolbar]
  }))));
};

var _default = /*#__PURE__*/_react.default.memo(TreeGrid);

exports.default = _default;