"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/asyncToGenerator"));

var _react = require("@testing-library/react");

var _TreeGrid = _interopRequireDefault(require("./TreeGrid"));

var _react2 = _interopRequireDefault(require("react"));

var _ej2ReactTreegrid = require("@syncfusion/ej2-react-treegrid");

var mGetRandomValues = jest.fn().mockReturnValueOnce(new Uint32Array(10));
Object.defineProperty(window, 'crypto', {
  value: {
    getRandomValues: mGetRandomValues
  }
}); //getRandomValue is mocked as it was called in syncfusion/treegrid and throwing err 

describe('rendering of components', function () {
  test('treegrid component is rendered', function () {
    (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null));
  });
  test('Syncfusion treegrid is rendered', function () {
    (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_ej2ReactTreegrid.TreeGridComponent, null));
  });
});
describe('Treegrid wrapper behaviour', function () {
  test('expand button is rendered intitially', function () {
    var _render = (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null)),
        queryByTestId = _render.queryByTestId,
        queryByPlaceholderText = _render.queryByPlaceholderText;

    expect(queryByTestId("expandbutton")).toBeTruthy();
  });
  test('collapsed button is rendered when grid is expanded', function () {
    var _render2 = (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null)),
        queryByTestId = _render2.queryByTestId,
        queryByPlaceholderText = _render2.queryByPlaceholderText;

    _react.fireEvent.click(_react.screen.queryByTestId("expandbutton"));

    expect(queryByTestId("collapsebutton")).toBeTruthy();
    expect(queryByTestId("expandbutton")).toBeFalsy();
  });
  test('width of wrapper is collapsed initially', function () {
    (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null));
    expect(_react.screen.getByTestId("treegrid-container")).toHaveClass("TreeGrid-container-short");
  });
  test('width of wrapper is expanded when expand button is clicked', function () {
    (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null));

    _react.fireEvent.click(_react.screen.queryByTestId("expandbutton"));

    expect(_react.screen.getByTestId("treegrid-container")).toHaveClass("TreeGrid-container-expanded");
  });
});
describe('Treegrid header behaviour', function () {
  test('header text is hidden when collapsed', /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee() {
    var _render3, container;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _render3 = (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null)), container = _render3.container;
            _context.next = 3;
            return new Promise(function (r) {
              return setTimeout(r, 100);
            });

          case 3:
            expect(container.getElementsByClassName('hide-treegridheader').length).toBeGreaterThan(0);

          case 4:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  })));
  test('header text is visible when expanded', function () {
    var _render4 = (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null)),
        container = _render4.container;

    _react.fireEvent.click(_react.screen.queryByTestId("expandbutton"));

    expect(container.getElementsByClassName('show-treegridheader').length).toBeGreaterThan(0);
  });
});
describe('Treegrid content overflow behaviour', function () {
  test('overflow is hidden when collapsed', /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee2() {
    var _render5, container;

    return _regenerator.default.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _render5 = (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null)), container = _render5.container;
            _context2.next = 3;
            return new Promise(function (r) {
              return setTimeout(r, 100);
            });

          case 3:
            expect(container.getElementsByClassName('hide-contentoverflow').length).toBeGreaterThan(0);

          case 4:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  })));
  test('overflow is auto when expanded', function () {
    var _render6 = (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null)),
        container = _render6.container;

    _react.fireEvent.click(_react.screen.queryByTestId("expandbutton"));

    expect(container.getElementsByClassName('show-contentoverflow').length).toBeGreaterThan(0);
  });
});
describe.skip('Treegrid border behaviour', function () {
  test('vertical border is hidden when collapsed', /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee3() {
    var _render7, container;

    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _render7 = (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null)), container = _render7.container;

            _react.fireEvent.click(_react.screen.queryByTestId("expandbutton"));

            _react.fireEvent.click(_react.screen.queryByTestId("collapsebutton"));

            _context3.next = 5;
            return new Promise(function (r) {
              return setTimeout(r, 1000);
            });

          case 5:
            expect(container.getElementsByClassName('hide-treegridborder').length).toBeGreaterThan(0);

          case 6:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  })));
  test('vertical border is visible when expanded', /*#__PURE__*/(0, _asyncToGenerator2.default)( /*#__PURE__*/_regenerator.default.mark(function _callee4() {
    var _render8, container;

    return _regenerator.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _render8 = (0, _react.render)( /*#__PURE__*/_react2.default.createElement(_TreeGrid.default, null)), container = _render8.container;

            _react.fireEvent.click(_react.screen.queryByTestId("expandbutton"));

            _context4.next = 4;
            return new Promise(function (r) {
              return setTimeout(r, 1000);
            });

          case 4:
            expect(container.getElementsByClassName('show-treegridborder').length).toBeGreaterThan(0);

          case 5:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  })));
});